/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


Main();


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // création du module AngularJS         
    var oModule = angular.module("AppliAngularJS", ["ngRoute"]);// création de la table de routage

    oModule.config(AppConfig);// pour les providers

    // déclaration des contrôleurs
    oModule.controller("MainControler", MainControler) 
      .controller("ViewControler", ViewControler)
      .controller('AppCtrl', AppControler);
}


/**
 * Permet de configuration le chemin de l'application
 *
 * @param {[type]} $routeProvider [description]
 */
function AppConfig($routeProvider)
{
    $routeProvider
        // chemin par défaut
      .when('/',
      {
        templateUrl: "app.html",// utilise le contenu du fichier app.html
        controller: "AppCtrl"
      })
      // si url complétée par /bonus
      .when('/bonus', {
        template: "<h3>Bonus validé ;)</h3>"
      })
      // si url complétée par /promo
      .when('/promo', {
        template: "<h3>Code promo activé;)</h3>"
      })
      // dans les autres cas, affiche une erreur
      .otherwise({
        template: "<err>Erreur, ce code n'existe pas !!!</err>"
      })
}

/**
 * Controler qui utilise la factory pour récupérer les données
 * 
 * @param {[type]} $scope [description]
 */
function AppControler($scope) 
{
    // la variable du fichier app.html
    $scope.model = {
        message: "--> Lancement de la formation Boost !!!"
    }
} 



/**
 * Déclaration des variables des vues
 * 
 * @param {[type]} $scope [description]
 */
function ViewControler($scope) 
{ 
    $scope.pageTitle = "Utilisation d'AngularJS"; 
} 
     

/**
 * Déclaration des variables nécessaires dans la zone gérée par AngularJS
 * 
 * @param {[type]} $scope [description]
 */
function MainControler($scope) 
{
    // représentation du modèle - les données
    $scope.user = { name: "Matthieu", site: "Développement Facile" }; 
    $scope.status = "banniere-cours-prog-facile-950";// affiche une image
    $scope.title = "Application Développement Facile"; 
} 
 
